Index: perl/modules/Jabber/lib/XML/Stream.pm
===================================================================
--- perl/modules/Jabber/lib/XML/Stream.pm	(revision a8d5a39837d6c308c7f46d0f78f528e6b9e6d54f)
+++ perl/modules/Jabber/lib/XML/Stream.pm	(revision 7869e4801e577613b7db987d11bddb0a31fe755c)
@@ -317,5 +317,5 @@
 
         my $lc = lc($module);
-        
+
         eval("\$HANDLERS{\$lc}->{startElement} = \\&XML::Stream::${module}::_handle_element;");
         eval("\$HANDLERS{\$lc}->{endElement}   = \\&XML::Stream::${module}::_handle_close;");
@@ -600,5 +600,5 @@
 
     my $root = $self->GetRoot($sid);
-    
+
     if ($root->{xmlns} ne $self->{SIDS}->{$serverid}->{namespace})
     {
@@ -668,5 +668,5 @@
     }
     while($#_ >= 0) { $self->{SIDS}->{newconnection}->{ lc pop(@_) } = pop(@_); }
-    
+
     my $timeout = exists($self->{SIDS}->{newconnection}->{timeout}) ?
                   delete($self->{SIDS}->{newconnection}->{timeout}) :
@@ -674,5 +674,5 @@
 
     $self->debug(4,"Connect: timeout($timeout)");
-    
+
 
     if (exists($self->{SIDS}->{newconnection}->{srv}))
@@ -683,7 +683,7 @@
             my $res = Net::DNS::Resolver->new();
             my $query = $res->query($self->{SIDS}->{newconnection}->{srv}.".".$self->{SIDS}->{newconnection}->{hostname},"SRV");
-            
+
             if ($query)
-            { 
+            {
                 $self->{SIDS}->{newconnection}->{hostname} = ($query->answer)[0]->target();
                 $self->{SIDS}->{newconnection}->{port} = ($query->answer)[0]->port();
@@ -771,5 +771,5 @@
         $self->{SIDS}->{newconnection}->{sock} =
             new FileHandle(">&STDOUT");
-    }  
+    }
 
     #---------------------------------------------------------------------------
@@ -1030,5 +1030,5 @@
     #---------------------------------------------------------------------------
     my %stream_args;
-    
+
     if (($self->{SIDS}->{$currsid}->{connectiontype} eq "tcpip") ||
         ($self->{SIDS}->{$currsid}->{connectiontype} eq "http"))
@@ -1036,5 +1036,5 @@
         $stream_args{to}= $self->{SIDS}->{$currsid}->{hostname}
             unless exists($self->{SIDS}->{$currsid}->{to});
-        
+
         $stream_args{to} = $self->{SIDS}->{$currsid}->{to}
             if exists($self->{SIDS}->{$currsid}->{to});
@@ -1044,8 +1044,8 @@
                 ($self->{SIDS}->{$currsid}->{myhostname} ne "")
                );
-        
+
         $stream_args{from} = $self->{SIDS}->{$currsid}->{from}
             if exists($self->{SIDS}->{$currsid}->{from});
-        
+
         $stream_args{id} = $self->{SIDS}->{$currsid}->{id}
             if (exists($self->{SIDS}->{$currsid}->{id}) &&
@@ -1055,5 +1055,5 @@
         $stream_args{namespaces} = $self->{SIDS}->{$currsid}->{namespaces};
     }
-    
+
     my $stream =
         $self->StreamHeader(
@@ -1172,5 +1172,5 @@
         }
     }
-        
+
     return $self->GetRoot($sid);
 }
@@ -1333,5 +1333,5 @@
     #---------------------------------------------------------------------------
     $self->{SIDS}->{$sid}->{streamfeatures}->{received} = 0;
-    
+
     #---------------------------------------------------------------------------
     # First acitivty is the connection... duh. =)
@@ -1522,5 +1522,5 @@
                 $self->debug(4,"Process: sid($sid) time(",time,") timeout(undef)");
             }
-            
+
             $self->Respond($sid)
                 if (exists($self->{SIDS}->{$sid}->{activitytimeout}) &&
@@ -1637,5 +1637,5 @@
     $self->debug(3,"Send: sid($sid)");
     $self->debug(3,"Send: status($self->{SIDS}->{$sid}->{status})");
-    
+
     $self->{SIDS}->{$sid}->{keepalive} = time;
 
@@ -1677,5 +1677,5 @@
                 return;
             }
-            
+
             $self->debug(4,"Send: SENDWRITTEN($self->{SENDWRITTEN})");
 
@@ -1736,5 +1736,5 @@
         }
     }
-    
+
     #-------------------------------------------------------------------------
     # XMPP-TLS - 1.0
@@ -1753,5 +1753,5 @@
         }
     }
-    
+
     #-------------------------------------------------------------------------
     # XMPP-Bind - 1.0
@@ -1762,5 +1762,5 @@
         $self->{SIDS}->{$sid}->{streamfeatures}->{'xmpp-bind'} = 1;
     }
-    
+
     #-------------------------------------------------------------------------
     # XMPP-Session - 1.0
@@ -1771,5 +1771,5 @@
         $self->{SIDS}->{$sid}->{streamfeatures}->{'xmpp-session'} = 1;
     }
-    
+
 }
 
@@ -1833,5 +1833,5 @@
         $self->TLSClientFailure($sid,$node);
     }
-    
+
     if ($tag eq "proceed")
     {
@@ -1853,5 +1853,5 @@
     $timeout = 120 unless defined($timeout);
     $timeout = 120 if ($timeout eq "");
-    
+
     $self->TLSStartTLS($sid);
 
@@ -1904,5 +1904,5 @@
         return;
     }
-    
+
     IO::Socket::SSL->start_SSL($self->{SIDS}->{$sid}->{sock},{SSL_verify_mode=>0x00});
 
@@ -1910,5 +1910,5 @@
     $self->debug(1,"TLSClientProceed: SSL: We are secure")
         if ($self->{SIDS}->{$sid}->{sock});
-    
+
     $self->{SIDS}->{$sid}->{tls}->{done} = 1;
     $self->{SIDS}->{$sid}->{tls}->{secure} = 1;
@@ -1925,5 +1925,5 @@
     my $self = shift;
     my $sid = shift;
-    
+
     return $self->{SIDS}->{$sid}->{tls}->{secure};
 }
@@ -1939,5 +1939,5 @@
     my $self = shift;
     my $sid = shift;
-    
+
     return $self->{SIDS}->{$sid}->{tls}->{done};
 }
@@ -1953,5 +1953,5 @@
     my $self = shift;
     my $sid = shift;
-    
+
     return $self->{SIDS}->{$sid}->{tls}->{error};
 }
@@ -1968,5 +1968,5 @@
     my $sid = shift;
     my $node = shift;
-    
+
     my $type = &XPath($node,"*/name()");
 
@@ -1986,5 +1986,5 @@
     my $sid = shift;
     my $type = shift;
-    
+
     $self->Send($sid,"<failure xmlns='".&ConstXMLNS('xmpp-tls')."'><${type}/></failure>");
 }
@@ -2018,10 +2018,10 @@
         $self->SASLAnswerChallenge($sid,$node);
     }
-    
+
     if ($tag eq "failure")
     {
         $self->SASLClientFailure($sid,$node);
     }
-    
+
     if ($tag eq "success")
     {
@@ -2045,5 +2045,5 @@
     my $challenge64 = &XPath($node,"text()");
     my $challenge = MIME::Base64::decode_base64($challenge64);
-    
+
     #-------------------------------------------------------------------------
     # As far as I can tell, if the challenge contains rspauth, then we authed.
@@ -2112,5 +2112,5 @@
 
     return unless defined($mechanisms);
-    
+
     my $sasl = new Authen::SASL(mechanism=>join(" ",@{$mechanisms}),
                                 callback=>{
@@ -2140,5 +2140,5 @@
     my $self = shift;
     my $sid = shift;
-    
+
     return $self->{SIDS}->{$sid}->{sasl}->{authed};
 }
@@ -2154,5 +2154,5 @@
     my $self = shift;
     my $sid = shift;
-    
+
     return $self->{SIDS}->{$sid}->{sasl}->{done};
 }
@@ -2168,5 +2168,5 @@
     my $self = shift;
     my $sid = shift;
-    
+
     return $self->{SIDS}->{$sid}->{sasl}->{error};
 }
@@ -2183,5 +2183,5 @@
     my $sid = shift;
     my $node = shift;
-    
+
     my $type = &XPath($node,"*/name()");
 
@@ -2201,5 +2201,5 @@
     my $sid = shift;
     my $node = shift;
-    
+
     $self->{SIDS}->{$sid}->{sasl}->{authed} = 1;
     $self->{SIDS}->{$sid}->{sasl}->{done} = 1;
@@ -2217,5 +2217,5 @@
     my $sid = shift;
     my $type = shift;
-    
+
     $self->Send($sid,"<failure xmlns='".&ConstXMLNS('xmpp-sasl')."'><${type}/></failure>");
 }
@@ -2292,5 +2292,5 @@
         # Make sure we are receiving a valid stream on the same namespace.
         #---------------------------------------------------------------------
-        
+
         $self->debug(3,"_handle_root: ($self->{SIDS}->{$self->{SIDS}->{$sid}->{serverid}}->{namespace})");
         $self->{SIDS}->{$sid}->{status} =
@@ -2328,5 +2328,5 @@
         }
     }
-    
+
     #-------------------------------------------------------------------------
     # Sometimes we will get an error, so let's parse the tag assuming that we
@@ -2335,5 +2335,5 @@
     my $stream_prefix = $self->StreamPrefix($sid);
     $self->debug(5,"_handle_root: stream_prefix($stream_prefix)");
-    
+
     if ($tag eq $stream_prefix.":error")
     {
@@ -2441,5 +2441,5 @@
     $self->{SIDS}->{$sid}->{streamerror}->{type} = "unknown";
     $self->{SIDS}->{$sid}->{streamerror}->{node} = $node;
-    
+
     #-------------------------------------------------------------------------
     # Check for older 0.9 streams and handle the errors for them.
@@ -2676,5 +2676,5 @@
     my $tree = shift;
     my $path = shift;
-    
+
     my $query = new XML::Stream::XPath::Query($path);
     my $result = $query->execute($tree);
@@ -2683,5 +2683,5 @@
         my %attribs = $result->getAttribs();
         return %attribs if (scalar(keys(%attribs)) > 0);
-        
+
         my @values = $result->getValues();
         @values = $result->getList() unless ($#values > -1);
@@ -2703,5 +2703,5 @@
     my $tree = shift;
     my $path = shift;
-    
+
     my $query = new XML::Stream::XPath::Query($path);
     my $result = $query->execute($tree);
@@ -2891,5 +2891,5 @@
 {
     my $const = shift;
-    
+
     return $XMLNS{$const};
 }
@@ -2905,5 +2905,5 @@
     my $self = shift;
     my $sid = shift;
-    
+
     return $self->ns2prefix($sid,&ConstXMLNS("stream"));
 }
@@ -2991,5 +2991,5 @@
 
     $self->debug(1,"LoadSSL: Load the IO::Socket::SSL module");
-    
+
     if (defined($SSL) && ($SSL == 1))
     {
@@ -2997,5 +2997,5 @@
         return 1;
     }
-    
+
     if (defined($SSL) && ($SSL == 0))
     {
@@ -3106,5 +3106,5 @@
         $stream .= " ".$ns->GetStream();
     }
-    
+
     $stream .= ">";
 
Index: perl/modules/Jabber/lib/XML/Stream/Namespace.pm
===================================================================
--- perl/modules/Jabber/lib/XML/Stream/Namespace.pm	(revision c2bed5539d456612d69de33e1dacc3afe5f70395)
+++ perl/modules/Jabber/lib/XML/Stream/Namespace.pm	(revision 7869e4801e577613b7db987d11bddb0a31fe755c)
@@ -25,5 +25,5 @@
 =head1 NAME
 
-XML::Stream::Namespace - Object to make defining Namespaces easier in 
+XML::Stream::Namespace - Object to make defining Namespaces easier in
                          XML::Stream.
 
@@ -49,6 +49,6 @@
   GetAttributes() returns a hash ( attrib1=>"value1",attrib2=>"value2")
   GetStream() returns the following string:
-    "xmlns:mynamespace='http://www.nynamespace.com/xmlns' 
-     mynamespace:attrib1='value1' 
+    "xmlns:mynamespace='http://www.nynamespace.com/xmlns'
+     mynamespace:attrib1='value1'
      mynamespace:attrib2='value2'"
 
@@ -71,13 +71,13 @@
   # of the stream to foo.bar.org:1234...
   #
-  #   <stream:stream 
+  #   <stream:stream
   #    xmlns:stream="http://etherx.jabber.org/streams"
   #    to="foo.bar.org"
-  #    xmlns="foo:bar" 
+  #    xmlns="foo:bar"
   #    xmlns:mynamespace="http://www.mynamespace.org/xmlns"
   #    mynamespace:foo="bar"
   #    mynamespace:bob="vila">
   #
-    
+
 
 =head1 AUTHOR
@@ -183,5 +183,5 @@
     $string .= "='".$self->GetAttributes($attrib)."'";
   }
-    
+
   return $string;
 }
Index: perl/modules/Jabber/lib/XML/Stream/Node.pm
===================================================================
--- perl/modules/Jabber/lib/XML/Stream/Node.pm	(revision c2bed5539d456612d69de33e1dacc3afe5f70395)
+++ perl/modules/Jabber/lib/XML/Stream/Node.pm	(revision 7869e4801e577613b7db987d11bddb0a31fe755c)
@@ -85,5 +85,5 @@
 
   remove_child(node) - removes the child node from the current node.
-  
+
   remove_cdata() - removes all of the cdata children from the current node.
 
@@ -120,5 +120,5 @@
 
   XPath(path) - run XML::Stream::XPath on this node.
-  
+
   XPathCheck(path) - run XML::Stream::XPath on this node and return 1 or 0
                      to see if it matches or not.
@@ -266,5 +266,5 @@
 
     return $cdata;
-} 
+}
 
 
@@ -286,5 +286,5 @@
         splice(@{$self->{CHILDREN}},$index,1);
     }
-} 
+}
 
 
@@ -294,5 +294,5 @@
     return () unless exists($self->{ATTRIBS});
     return %{$self->{ATTRIBS}};
-} 
+}
 
 
@@ -308,5 +308,5 @@
 
 sub put_attrib
-{ 
+{
     my $self = shift;
     my (%att) = @_;
@@ -366,5 +366,5 @@
     my ($tag) = @_;
 
-    $self->{TAG} = $tag; 
+    $self->{TAG} = $tag;
 }
 
@@ -513,5 +513,5 @@
 
     $self->debug(2,"Node: _handle_close: check2(",$#{$self->{SIDS}->{$sid}->{node}},")");
-    
+
     if($#{$self->{SIDS}->{$sid}->{node}} == -1)
     {
@@ -521,5 +521,5 @@
         {
             my $stream_prefix = $self->StreamPrefix($sid);
-            
+
             if(defined($self->{SIDS}->{$sid}->{node}->[0]) &&
                ($self->{SIDS}->{$sid}->{node}->[0]->get_tag() =~ /^${stream_prefix}\:/))
@@ -542,5 +542,5 @@
                 {
                     my $xmlns = $node->get_attrib("xmlns");
-                    
+
                     $self->ProcessSASLPacket($sid,$node)
                         if ($xmlns eq &XML::Stream::ConstXMLNS("xmpp-sasl"));
Index: perl/modules/Jabber/lib/XML/Stream/Parser.pm
===================================================================
--- perl/modules/Jabber/lib/XML/Stream/Parser.pm	(revision c2bed5539d456612d69de33e1dacc3afe5f70395)
+++ perl/modules/Jabber/lib/XML/Stream/Parser.pm	(revision 7869e4801e577613b7db987d11bddb0a31fe755c)
@@ -324,5 +324,5 @@
                 $self->{CNAME}->[$self->{CURR}] = $name;
             }
-    
+
             $self->{XML} = substr($self->{XML},$close+1,length($self->{XML})-$close-1);
             next;
@@ -337,7 +337,7 @@
                 return $self->returnData(0);
             }
-            
+
             &{$self->{HANDLER}->{characters}}($self,substr($self->{XML},9,$cdataclose-9));
-            
+
             $self->{XML} = substr($self->{XML},$cdataclose+3,length($self->{XML})-$cdataclose-3);
             next;
@@ -510,5 +510,5 @@
     return unless ($self->{DOC} == 1);
 
-    if ($self->{STYLE} eq "debug") 
+    if ($self->{STYLE} eq "debug")
     {
         my $str = $cdata;
@@ -530,5 +530,5 @@
             push @{$self->{TREE}[$#{$self->{TREE}}]}, 0;
             push @{$self->{TREE}[$#{$self->{TREE}}]}, $cdata;
-        }  
+        }
     }
 }
Index: perl/modules/Jabber/lib/XML/Stream/Tree.pm
===================================================================
--- perl/modules/Jabber/lib/XML/Stream/Tree.pm	(revision c2bed5539d456612d69de33e1dacc3afe5f70395)
+++ perl/modules/Jabber/lib/XML/Stream/Tree.pm	(revision 7869e4801e577613b7db987d11bddb0a31fe755c)
@@ -142,5 +142,5 @@
         push @{$self->{SIDS}->{$sid}->{tree}[$#{$self->{SIDS}->{$sid}->{tree}}]}, 0;
         push @{$self->{SIDS}->{$sid}->{tree}[$#{$self->{SIDS}->{$sid}->{tree}}]}, $cdata;
-    }  
+    }
 }
 
@@ -187,5 +187,5 @@
             if(defined($self->{SIDS}->{$sid}->{tree}->[0]) &&
                ($self->{SIDS}->{$sid}->{tree}->[0] =~ /^${stream_prefix}\:/))
-            { 
+            {
                 my @tree = @{$self->{SIDS}->{$sid}->{tree}};
                 $self->{SIDS}->{$sid}->{tree} = [];
@@ -196,5 +196,5 @@
                 my @tree = @{$self->{SIDS}->{$sid}->{tree}};
                 $self->{SIDS}->{$sid}->{tree} = [];
-                
+
                 my @special =
                     &XML::Stream::XPath(
@@ -384,5 +384,5 @@
                     return 1;
                 }
-                
+
                 #---------------------------------------------------------------------
                 # Return the raw CDATA value without mark ups, or the value of the
@@ -592,5 +592,5 @@
 
     my $str = "";
-    if (ref($parseTree->[0]) eq "") 
+    if (ref($parseTree->[0]) eq "")
     {
         if ($parseTree->[0] eq "0")
@@ -608,5 +608,5 @@
         {
             $str .= ">";
-            
+
             my $index = 1;
             while($index <= $#{$parseTree->[1]})
@@ -616,5 +616,5 @@
                 $index += 2;
             }
-            
+
             $str .= $rawXML if defined($rawXML);
             $str .= "</".$parseTree->[0].">";
Index: perl/modules/Jabber/lib/XML/Stream/XPath/Op.pm
===================================================================
--- perl/modules/Jabber/lib/XML/Stream/XPath/Op.pm	(revision c2bed5539d456612d69de33e1dacc3afe5f70395)
+++ perl/modules/Jabber/lib/XML/Stream/XPath/Op.pm	(revision 7869e4801e577613b7db987d11bddb0a31fe755c)
@@ -50,5 +50,5 @@
     $self->{TYPE} = shift;
     $self->{VALUE} = shift;
-    
+
     return $self;
 }
@@ -165,9 +165,9 @@
         {
             push(@valid_elems,$elem);
-        }   
-    }
-
-    $$ctxt->setList(@valid_elems);
-    
+        }
+    }
+
+    $$ctxt->setList(@valid_elems);
+
     if ($#valid_elems == -1)
     {
@@ -224,10 +224,10 @@
 
     my @valid_elems;
-    
+
     foreach my $elem (@elems)
     {
         push(@valid_elems,$self->descend($elem));
     }
-    
+
     $$ctxt->setList(@valid_elems);
 
@@ -247,15 +247,15 @@
 
     my @valid_elems;
-    
+
     if (($self->{VALUE} eq "*") || (&XML::Stream::GetXMLData("tag",$elem) eq $self->{VALUE}))
     {
         push(@valid_elems,$elem);
     }
-    
+
     foreach my $child (&XML::Stream::GetXMLData("child array",$elem,"*"))
     {
         push(@valid_elems,$self->descend($child));
     }
-    
+
     return @valid_elems;
 }
@@ -326,5 +326,5 @@
         }
     }
-    
+
     $$ctxt->setList(@valid_elems);
 
@@ -343,5 +343,5 @@
     my $elem = shift;
     return &XML::Stream::GetXMLData("value",$elem);
-} 
+}
 
 
@@ -374,5 +374,5 @@
     $tmp_ctxt->setList($$ctxt->getList());
     $tmp_ctxt->in_context(0);
-    
+
     if (!$self->{OP_L}->isValid(\$tmp_ctxt) || !$self->{OP_R}->isValid(\$tmp_ctxt))
     {
@@ -393,5 +393,5 @@
         @valid_elems = $$ctxt->getList();
     }
-    
+
     $$ctxt->setList(@valid_elems);
 
@@ -414,5 +414,5 @@
     print $space,"    op_l: ";
     $self->{OP_L}->display($space."    ");
-    
+
     print $space,"    op_r: ";
     $self->{OP_R}->display($space."    ");
@@ -449,5 +449,5 @@
     $tmp_ctxt->setList($$ctxt->getList());
     $tmp_ctxt->in_context(0);
-    
+
     if (!$self->{OP_L}->isValid(\$tmp_ctxt) || !$self->{OP_R}->isValid(\$tmp_ctxt))
     {
@@ -468,5 +468,5 @@
         @valid_elems = $$ctxt->getList();
     }
-    
+
     $$ctxt->setList(@valid_elems);
 
@@ -489,5 +489,5 @@
     print $space,"    op_l: ";
     $self->{OP_L}->display($space."    ");
-    
+
     print $space,"    op_r: ";
     $self->{OP_R}->display($space."    ");
@@ -524,5 +524,5 @@
     my @values;
     my %attribs;
-    
+
     foreach my $elem (@elems)
     {
@@ -558,5 +558,5 @@
         return;
     }
-    
+
     return 1;
 }
@@ -607,5 +607,5 @@
     my $opl = $self->{OP_L}->isValid($ctxt);
     my $opr = $self->{OP_R}->isValid($ctxt);
-    
+
     if ($opl && $opr)
     {
@@ -628,5 +628,5 @@
     print $space,"  op_l: \n";
     $self->{OP_L}->display($space."    ");
-    
+
     print $space,"  op_r: \n";
     $self->{OP_R}->display($space."    ");
@@ -672,13 +672,13 @@
         my $opl = $self->{OP_L}->isValid(\$tmp_ctxt_l);
         my $opr = $self->{OP_R}->isValid(\$tmp_ctxt_r);
-    
+
         if ($opl || $opr)
         {
             push(@valid_elems,$elem);
-        }   
-    }
-
-    $$ctxt->setList(@valid_elems);
-    
+        }
+    }
+
+    $$ctxt->setList(@valid_elems);
+
     if ($#valid_elems == -1)
     {
@@ -699,5 +699,5 @@
     print "$space    op_l: ";
     $self->{OP_L}->display("$space    ");
-    
+
     print "$space    op_r: ";
     $self->{OP_R}->display("$space    ");
@@ -750,5 +750,5 @@
     my $self = shift;
     my $elem = shift;
-    
+
     my $result;
     eval("\$result = &{\$XML::Stream::XPath::VALUES{\$self->{VALUE}}}(\$elem);");
@@ -790,10 +790,10 @@
             push(@valid_elems,$elem);
             push(@valid_values,$text);
-        }   
+        }
     }
 
     $$ctxt->setList(@valid_elems);
     $$ctxt->setValues(@valid_values);
-    
+
     if ($#valid_elems == -1)
     {
@@ -819,9 +819,9 @@
         {
             push(@valid_elems,$elem);
-        }   
-    }
-
-    $$ctxt->setList(@valid_elems);
-    
+        }
+    }
+
+    $$ctxt->setList(@valid_elems);
+
     if ($#valid_elems == -1)
     {
@@ -848,10 +848,10 @@
             push(@valid_elems,$elem);
             push(@valid_values,$text);
-        }   
+        }
     }
 
     $$ctxt->setList(@valid_elems);
     $$ctxt->setValues(@valid_values);
-    
+
     if ($#valid_elems == -1)
     {
@@ -878,9 +878,9 @@
         {
             push(@valid_elems,$elem);
-        }   
-    }
-
-    $$ctxt->setList(@valid_elems);
-    
+        }
+    }
+
+    $$ctxt->setList(@valid_elems);
+
     if ($#valid_elems == -1)
     {
Index: perl/modules/Jabber/lib/XML/Stream/XPath/Query.pm
===================================================================
--- perl/modules/Jabber/lib/XML/Stream/XPath/Query.pm	(revision c2bed5539d456612d69de33e1dacc3afe5f70395)
+++ perl/modules/Jabber/lib/XML/Stream/XPath/Query.pm	(revision 7869e4801e577613b7db987d11bddb0a31fe755c)
@@ -37,14 +37,14 @@
     bless($self,$proto);
 
-    $self->{TOKENS} = [ '/','[',']','@','"',"'",'=','!','(',')',':',' ',',']; 
+    $self->{TOKENS} = [ '/','[',']','@','"',"'",'=','!','(',')',':',' ',','];
     $self->{QUERY} = shift;
-    
+
     if (!defined($self->{QUERY}) || ($self->{QUERY} eq ""))
     {
         confess("No query string specified");
     }
-    
+
     $self->parseQuery();
-    
+
     return $self;
 }
@@ -52,5 +52,5 @@
 
 sub getNextToken
-{ 
+{
     my $self = shift;
     my $pos = shift;
@@ -104,5 +104,5 @@
         my $token_start = ++$$pos;
         my $ident;
-     
+
         if (defined($token))
         {
@@ -193,5 +193,5 @@
                         return;
                     }
-                    
+
                     $$pos = $token_start;
                     my $val = $self->getNextIdentifier($pos);
@@ -234,5 +234,5 @@
 
                 $self->getOp($pos,$token);
-                
+
                 foreach my $arg ($op_pos..$#{$self->{OPS}})
                 {
@@ -241,5 +241,5 @@
 
                 splice(@{$self->{OPS}},$op_pos);
-                
+
             }
             elsif ($token eq ")")
@@ -261,5 +261,5 @@
                     confess("Found ',' but not in a function");
                 }
-  
+
             }
             elsif ($token eq "=")
@@ -280,5 +280,5 @@
                 }
                 $$pos++;
-                
+
                 my $tmp_op;
                 while(!defined($tmp_op))
@@ -307,5 +307,5 @@
             confess("Token undefined");
         }
-        
+
         $loop = 0 unless $in_context;
     }
Index: perl/modules/Jabber/lib/XML/Stream/XPath/Value.pm
===================================================================
--- perl/modules/Jabber/lib/XML/Stream/XPath/Value.pm	(revision c2bed5539d456612d69de33e1dacc3afe5f70395)
+++ perl/modules/Jabber/lib/XML/Stream/XPath/Value.pm	(revision 7869e4801e577613b7db987d11bddb0a31fe755c)
@@ -96,5 +96,5 @@
 
 sub getAttribs
-{ 
+{
     my $self = shift;
     return unless (scalar(keys(%{$self->{ATTRIBS}})) > 0);